Setting Live ‘Bing Keyword Performance’ Tasks


You can receive a set of keyword performance stats for a group of keywords depending on the specified match type, location and language parameters. Ad position, clicks, impressions, and other keyword metrics are aggregated for the last month for one or all of the following device types: mobile, desktop, tablet.

Note: Refer to the Bing Ads Status endpoint to verify that Bing updated the keyword data for the previous month.

You will get information separately for each keyword specified in a POST array.

If your system requires delivering instant results, the Live method is the best solution for you. Unlike the Standard method, this method doesn’t require making separate POST and GET requests to the corresponding endpoints.

If you don’t need to receive data in real-time, you can use the the Standard method method of data retrieval. This method requires making separate POST and GET requests, but it’s more affordable. Using this method you can retrieve the results after our system collects them.

checked POST
Pricing

Your account will be charged only for setting a task.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You can send up to 2500 keywords in one keywords array. Our system will charge your account per request, no matter what number of keywords an array has, the price for 1 or 1000 keywords will be the same.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

keywords
required field
The maximum number of keywords you can specify: 1000
The maximum number of characters for each keyword: 80
The maximum number of words for each keyword phrase: 10
the specified keywords will be converted to lowercase, data will be provided in a separate array

learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

devicestring

device type
optional field
specify this field if you want to get the data for a particular device typepossible values: desktop, mobile, tablet, all
default value: all

matchstring

keywords match type
optional field
can take the following values:
aggregate returns data across all match types;
broad returns data for all user queries containing the specified keyword with varying word order;
phrase returns data for all user queries containing the specified keyword with identical word order;
exact returns data for user query that matches the specified keyword;Note: the aggregate match type is applied by default

location_namestring

full name of search engine location
required field if you don't specify location_code or location_coordinate
if you use this field, you don't need to specify location_code or location_coordinate
you can receive the list of available locations and languages by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/keyword_performance/locations_and_languages
example:
"United States"

location_codeinteger

search engine location code
required field if you don't specify location_name or location_coordinate
if you use this field, you don't need to specify location_name or location_coordinate
you can receive the list of available locations and languages by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/keyword_performance/locations_and_languages
example:
2840

location_coordinatestring

GPS coordinates of a location
required field if you don't specify location_name or location_code
if you use this field, you don't need to specify location_name or location_code
location_coordinate parameter should be specified in the "latitude,longitude" format
the data will be provided for the country the specified coordinates belong to
example:
52.6178549,-155.352142

language_namestring

full name of search engine language
required field if you don't specify language_code
if you use this field, you don't need to specify language_code
you can receive the list of available locations and languages by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/keyword_performance/locations_and_languages
example:
English

language_codestring

search engine language code
required field if you don't specify language_name
you can receive the list of available locations and languages by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/keyword_performance/locations_and_languages
example:
"en"

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


‌‌
‌‌As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword in a POST array

        location_codeinteger

location code in a POST array
if there is no data, then the value is_nulln

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        yearinteger

indicates the year for which the data is provided for
example:
2020

        monthinteger

indicates the month for which the data is provided for
example:
10

        keyword_kpiobject

object containing keyword metrics
if there is no data, then the value is_nulln

            desktoparray

keyword data aggregated for desktop devices
if there is no data, then the value is_nulln

                ad_positionstring

represents the position of the relevant ad in SERP
can take the following values:
FirstPage1: The first ad to appear on the right side of the first search results page
FirstPage2: The second ad to appear on the right side of the first search results page
FirstPage3: The third ad to appear on the right side of the first search results page
FirstPage4: The fourth ad to appear on the right side of the first search results page
FirstPage5: The fifth ad to appear on the right side of the first search results page
FirstPage6: The sixth ad to appear on the right side of the first search results page
FirstPage7: The seventh ad to appear on the right side of the first search results page
FirstPage8: The eighth ad to appear on the right side of the first search results page
FirstPage9: The ninth ad to appear on the right side of the first search results page
FirstPage10: The tenth ad to appear on the right side of the first search results page
MainLine1: The first ad to appear at the top of the search results page
MainLine2: The second ad to appear at the top of the search results page
MainLine3: The third ad to appear at the top of the search results page
MainLine4: The fourth ad to appear at the top of the search results page

                clicksinteger

ad clicks
the number of clicks that the keyword and match type generated during the last month

                impressionsinteger

ad impressions
the number of impressions that the keyword and match type generated during the last month

                average_cpcinteger

average cost per click, USD
calculated by dividing the cost of all clicks by the number of clicks

                ctrinteger

click-through rate as a percentage
calculated by dividing the number of clicks by the number of impressions and multiplying the result by 100

                total_costinteger

total cost of an ad, USD
the cost of using the specified keyword and match type during the last month

                average_bidinteger

average bid of the keyword

            mobilearray

keyword data aggregated for mobile devices
if there is no data, then the value is_nulln

                ad_positionstring

represents the position of the relevant ad in SERP
can take the following values:
FirstPage1: The first ad to appear on the right side of the first search results page
FirstPage2: The second ad to appear on the right side of the first search results page
FirstPage3: The third ad to appear on the right side of the first search results page
FirstPage4: The fourth ad to appear on the right side of the first search results page
FirstPage5: The fifth ad to appear on the right side of the first search results page
FirstPage6: The sixth ad to appear on the right side of the first search results page
FirstPage7: The seventh ad to appear on the right side of the first search results page
FirstPage8: The eighth ad to appear on the right side of the first search results page
FirstPage9: The ninth ad to appear on the right side of the first search results page
FirstPage10: The tenth ad to appear on the right side of the first search results page
MainLine1: The first ad to appear at the top of the search results page
MainLine2: The second ad to appear at the top of the search results page
MainLine3: The third ad to appear at the top of the search results page
MainLine4: The fourth ad to appear at the top of the search results page

                clicksinteger

ad clicks
the number of clicks that the keyword and match type generated during the last month

                impressionsinteger

ad impressions
the number of impressions that the keyword and match type generated during the last month

                average_cpcinteger

average cost per click, USD
calculated by dividing the cost of all clicks by the number of clicks

                ctrinteger

click-through rate as a percentage
calculated by dividing the number of clicks by the number of impressions and multiplying the result by 100

                total_costinteger

total cost of an ad, USD
the cost of using the specified keyword and match type during the last month

                average_bidinteger

average bid of the keyword

            tabletarray

keyword data aggregated for tablet devices
if there is no data, then the value is_nulln

                ad_positionstring

represents the position of the relevant ad in SERP
can take the following values:
FirstPage1: The first ad to appear on the right side of the first search results page
FirstPage2: The second ad to appear on the right side of the first search results page
FirstPage3: The third ad to appear on the right side of the first search results page
FirstPage4: The fourth ad to appear on the right side of the first search results page
FirstPage5: The fifth ad to appear on the right side of the first search results page
FirstPage6: The sixth ad to appear on the right side of the first search results page
FirstPage7: The seventh ad to appear on the right side of the first search results page
FirstPage8: The eighth ad to appear on the right side of the first search results page
FirstPage9: The ninth ad to appear on the right side of the first search results page
FirstPage10: The tenth ad to appear on the right side of the first search results page
MainLine1: The first ad to appear at the top of the search results page
MainLine2: The second ad to appear at the top of the search results page
MainLine3: The third ad to appear at the top of the search results page
MainLine4: The fourth ad to appear at the top of the search results page

                clicksinteger

ad clicks
the number of clicks that the keyword and match type generated during the last month

                impressionsinteger

ad impressions
the number of impressions that the keyword and match type generated during the last month

                average_cpcinteger

average cost per click, USD
calculated by dividing the cost of all clicks by the number of clicks

                ctrinteger

click-through rate as a percentage
calculated by dividing the number of clicks by the number of impressions and multiplying the result by 100

                total_costinteger

total cost of an ad, USD
the cost of using the specified keyword and match type during the last month

                average_bidinteger

average bid of the keyword


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/bing/keyword_performance/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "location_code": 2840,
        "language_code": "en",
        "keywords": [
            "dataforseo",
            "seo",
            "ranking"
        ]
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
    // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
    $client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
    echo "n";
    print "HTTP code: {$e->getHttpCode()}n";
    print "Error code: {$e->getCode()}n";
    print "Message: {$e->getMessage()}n";
    print  $e->getTraceAsString();
    echo "n";
    exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
    "location_name" => "United States",
    "language_name" => "English",
    "keywords" => array(
        "dataforseo",
        "seo",
        "ranking"
    )
);
try {
    // POST /v3/keywords_data/bing/keyword_performance/live
    // the full list of possible parameters is available in documentation
    $result = $client->post('/v3/keywords_data/bing/keyword_performance/live', $post_array);
    print_r($result);
    // do something with post result
} catch (RestClientException $e) {
    echo "n";
    print "HTTP code: {$e->getHttpCode()}n";
    print "Error code: {$e->getCode()}n";
    print "Message: {$e->getMessage()}n";
    print  $e->getTraceAsString();
    echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "location_name": "United States",
  "language_name": "English",
  "keywords": ["dataforseo", "seo", "ranking"]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/bing/keyword_performance/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
  location_name="United States",
  language_name="English",
  keywords=[
    "dataforseo",
    "seo",
    "ranking"
  ]
)
# POST /v3/keywords_data/bing/keyword_performance/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/bing/keyword_performance/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
    else:
        print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_keyword_performance_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_name = "United States",
                language_name = "English",
                keywords = new[]
                    {
                        "dataforseo",
                        "seo",
                        "ranking"
                    }
            });
            // POST /v3/keywords_data/bing/keyword_performance/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/bing/keyword_performance/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
    "version": "0.1.20201021",
    "status_code": 20000,
    "status_message": "Ok.",
    "time": "11.8263 sec.",
    "cost": 0.05,
    "tasks_count": 1,
    "tasks_error": 0,
    "tasks": [
        {
            "id": "10212029-1535-0252-0000-6be9f05b283b",
            "status_code": 20000,
            "status_message": "Ok.",
            "time": "11.7263 sec.",
            "cost": 0.05,
            "result_count": 3,
            "path": [
                "v3",
                "keywords_data",
                "bing",
                "keyword_performance",
                "live"
            ],
            "data": {
                "api": "keywords_data",
                "function": "keyword_performance",
                "se": "bing",
                "location_code": 1026218,
                "language_code": "en",
                "keywords": [
                    "dataforseo",
                    "seo",
                    "ranking"
                ]
            },
            "result": [
                {
                    "keyword": "dataforseo",
                    "location_code": 1026218,
                    "language_code": "en",
                    "year": 2020,
                    "month": 9,
                    "keyword_kpi": {
                        "desktop": [
                            {
                                "ad_position": "MainLine1",
                                "clicks": 2,
                                "impressions": 27,
                                "average_cpc": 4.825,
                                "ctr": 7.407407283782959,
                                "total_cost": 9.65,
                                "average_bid": 5.38037037037037
                            },
                            {
                                "ad_position": "MainLine2",
                                "clicks": 0,
                                "impressions": 16,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 3.5825
                            }
                        ],
                        "mobile": null,
                        "tablet": null
                    }
                },
                {
                    "keyword": "seo",
                    "location_code": 1026218,
                    "language_code": "en",
                    "year": 2020,
                    "month": 9,
                    "keyword_kpi": {
                        "desktop": [
                            {
                                "ad_position": "MainLine1",
                                "clicks": 847,
                                "impressions": 50016,
                                "average_cpc": 4.745868,
                                "ctr": 1.693458080291748,
                                "total_cost": 4019.75,
                                "average_bid": 5.67275711772233
                            },
                            {
                                "ad_position": "MainLine2",
                                "clicks": 349,
                                "impressions": 28763,
                                "average_cpc": 3.03341,
                                "ctr": 1.2133643627166748,
                                "total_cost": 1058.66,
                                "average_bid": 3.84867086187116
                            },
                            {
                                "ad_position": "MainLine3",
                                "clicks": 140,
                                "impressions": 16296,
                                "average_cpc": 2.295786,
                                "ctr": 0.8591065406799316,
                                "total_cost": 321.41,
                                "average_bid": 2.75259941089838
                            },
                            {
                                "ad_position": "MainLine4",
                                "clicks": 94,
                                "impressions": 10895,
                                "average_cpc": 1.82117,
                                "ctr": 0.8627811074256897,
                                "total_cost": 171.19,
                                "average_bid": 2.18497384121156
                            },
                            {
                                "ad_position": "FirstPage1",
                                "clicks": 8,
                                "impressions": 5358,
                                "average_cpc": 0.06,
                                "ctr": 0.149309441447258,
                                "total_cost": 0.48,
                                "average_bid": 0.772810750279955
                            },
                            {
                                "ad_position": "FirstPage2",
                                "clicks": 3,
                                "impressions": 3103,
                                "average_cpc": 0.01666667,
                                "ctr": 0.09668063372373581,
                                "total_cost": 0.05,
                                "average_bid": 0.219378021269739
                            },
                            {
                                "ad_position": "FirstPage3",
                                "clicks": 2,
                                "impressions": 2158,
                                "average_cpc": 0.07,
                                "ctr": 0.09267840534448624,
                                "total_cost": 0.14,
                                "average_bid": 0.113484708063021
                            },
                            {
                                "ad_position": "FirstPage4",
                                "clicks": 0,
                                "impressions": 1064,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0866259398496241
                            },
                            {
                                "ad_position": "FirstPage5",
                                "clicks": 0,
                                "impressions": 741,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0912415654520918
                            },
                            {
                                "ad_position": "FirstPage6",
                                "clicks": 1,
                                "impressions": 553,
                                "average_cpc": 0.02,
                                "ctr": 0.18083181977272034,
                                "total_cost": 0.02,
                                "average_bid": 0.08625678119349
                            },
                            {
                                "ad_position": "FirstPage7",
                                "clicks": 0,
                                "impressions": 292,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0822602739726028
                            },
                            {
                                "ad_position": "FirstPage8",
                                "clicks": 0,
                                "impressions": 248,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0673387096774194
                            },
                            {
                                "ad_position": "FirstPage9",
                                "clicks": 0,
                                "impressions": 32,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage10",
                                "clicks": 0,
                                "impressions": 14,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            }
                        ],
                        "mobile": [
                            {
                                "ad_position": "MainLine1",
                                "clicks": 537,
                                "impressions": 13215,
                                "average_cpc": 0.7699441,
                                "ctr": 4.063564300537109,
                                "total_cost": 413.46,
                                "average_bid": 5.17993719258418
                            },
                            {
                                "ad_position": "MainLine2",
                                "clicks": 425,
                                "impressions": 12396,
                                "average_cpc": 0.8124941,
                                "ctr": 3.428525447845459,
                                "total_cost": 345.31,
                                "average_bid": 5.26122136172959
                            },
                            {
                                "ad_position": "MainLine3",
                                "clicks": 123,
                                "impressions": 4669,
                                "average_cpc": 0.4292683,
                                "ctr": 2.634397029876709,
                                "total_cost": 52.8,
                                "average_bid": 2.85917112872135
                            },
                            {
                                "ad_position": "MainLine4",
                                "clicks": 33,
                                "impressions": 1913,
                                "average_cpc": 0.1439394,
                                "ctr": 1.7250392436981201,
                                "total_cost": 4.75,
                                "average_bid": 0.830397281756404
                            },
                            {
                                "ad_position": "FirstPage1",
                                "clicks": 33,
                                "impressions": 1236,
                                "average_cpc": 0.02727273,
                                "ctr": 2.669902801513672,
                                "total_cost": 0.9,
                                "average_bid": 0.0551779935275081
                            },
                            {
                                "ad_position": "FirstPage2",
                                "clicks": 0,
                                "impressions": 32,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.3271875
                            },
                            {
                                "ad_position": "FirstPage3",
                                "clicks": 0,
                                "impressions": 9,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.297777777777778
                            },
                            {
                                "ad_position": "FirstPage4",
                                "clicks": 0,
                                "impressions": 7,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.108571428571429
                            },
                            {
                                "ad_position": "FirstPage5",
                                "clicks": 0,
                                "impressions": 1,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            }
                        ],
                        "tablet": [
                            {
                                "ad_position": "MainLine3",
                                "clicks": 12,
                                "impressions": 250,
                                "average_cpc": 0.3775,
                                "ctr": 4.800000190734863,
                                "total_cost": 4.53,
                                "average_bid": 1.47264
                            },
                            {
                                "ad_position": "MainLine1",
                                "clicks": 11,
                                "impressions": 876,
                                "average_cpc": 1.633636,
                                "ctr": 1.2557077407836914,
                                "total_cost": 17.97,
                                "average_bid": 5.92456621004566
                            },
                            {
                                "ad_position": "MainLine2",
                                "clicks": 15,
                                "impressions": 435,
                                "average_cpc": 0.62,
                                "ctr": 3.4482758045196533,
                                "total_cost": 9.3,
                                "average_bid": 2.27634482758621
                            },
                            {
                                "ad_position": "MainLine4",
                                "clicks": 10,
                                "impressions": 179,
                                "average_cpc": 0.228,
                                "ctr": 5.586592197418213,
                                "total_cost": 2.28,
                                "average_bid": 0.828882681564246
                            },
                            {
                                "ad_position": "FirstPage1",
                                "clicks": 0,
                                "impressions": 92,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.509565217391304
                            },
                            {
                                "ad_position": "FirstPage3",
                                "clicks": 0,
                                "impressions": 20,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.139
                            },
                            {
                                "ad_position": "FirstPage5",
                                "clicks": 0,
                                "impressions": 15,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.109333333333333
                            },
                            {
                                "ad_position": "FirstPage7",
                                "clicks": 0,
                                "impressions": 3,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0566666666666667
                            },
                            {
                                "ad_position": "FirstPage2",
                                "clicks": 0,
                                "impressions": 18,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.452222222222222
                            },
                            {
                                "ad_position": "FirstPage4",
                                "clicks": 0,
                                "impressions": 16,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.08625
                            },
                            {
                                "ad_position": "FirstPage6",
                                "clicks": 0,
                                "impressions": 7,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0514285714285714
                            },
                            {
                                "ad_position": "FirstPage8",
                                "clicks": 0,
                                "impressions": 3,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0733333333333334
                            }
                        ]
                    }
                },
                {
                    "keyword": "ranking",
                    "location_code": 1026218,
                    "language_code": "en",
                    "year": 2020,
                    "month": 9,
                    "keyword_kpi": {
                        "desktop": [
                            {
                                "ad_position": "MainLine1",
                                "clicks": 21,
                                "impressions": 1055,
                                "average_cpc": 0.04761905,
                                "ctr": 1.9905213117599487,
                                "total_cost": 1,
                                "average_bid": 0.0580473933649289
                            },
                            {
                                "ad_position": "MainLine2",
                                "clicks": 3,
                                "impressions": 1398,
                                "average_cpc": 0.05,
                                "ctr": 0.21459227800369263,
                                "total_cost": 0.15,
                                "average_bid": 0.0697639484978541
                            },
                            {
                                "ad_position": "MainLine3",
                                "clicks": 1,
                                "impressions": 1275,
                                "average_cpc": 0.05,
                                "ctr": 0.0784313753247261,
                                "total_cost": 0.05,
                                "average_bid": 0.0701960784313726
                            },
                            {
                                "ad_position": "FirstPage1",
                                "clicks": 0,
                                "impressions": 626,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0521884984025559
                            },
                            {
                                "ad_position": "MainLine4",
                                "clicks": 0,
                                "impressions": 816,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0516544117647059
                            },
                            {
                                "ad_position": "FirstPage2",
                                "clicks": 0,
                                "impressions": 141,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage3",
                                "clicks": 0,
                                "impressions": 100,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0589
                            },
                            {
                                "ad_position": "FirstPage5",
                                "clicks": 0,
                                "impressions": 39,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.051025641025641
                            },
                            {
                                "ad_position": "FirstPage4",
                                "clicks": 0,
                                "impressions": 49,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0575510204081633
                            },
                            {
                                "ad_position": "FirstPage6",
                                "clicks": 0,
                                "impressions": 35,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage7",
                                "clicks": 0,
                                "impressions": 12,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage8",
                                "clicks": 0,
                                "impressions": 7,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            }
                        ],
                        "mobile": [
                            {
                                "ad_position": "MainLine1",
                                "clicks": 47,
                                "impressions": 1758,
                                "average_cpc": 0.03808511,
                                "ctr": 2.673492670059204,
                                "total_cost": 1.79,
                                "average_bid": 0.0507849829351536
                            },
                            {
                                "ad_position": "MainLine2",
                                "clicks": 17,
                                "impressions": 827,
                                "average_cpc": 0.04588235,
                                "ctr": 2.0556228160858154,
                                "total_cost": 0.78,
                                "average_bid": 0.0501571946795647
                            },
                            {
                                "ad_position": "MainLine3",
                                "clicks": 0,
                                "impressions": 40,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0535
                            },
                            {
                                "ad_position": "MainLine4",
                                "clicks": 1,
                                "impressions": 28,
                                "average_cpc": 0.05,
                                "ctr": 3.5714285373687744,
                                "total_cost": 0.05,
                                "average_bid": 0.0510714285714286
                            },
                            {
                                "ad_position": "FirstPage1",
                                "clicks": 2,
                                "impressions": 30,
                                "average_cpc": 0.015,
                                "ctr": 6.666666507720947,
                                "total_cost": 0.03,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage2",
                                "clicks": 0,
                                "impressions": 14,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage3",
                                "clicks": 0,
                                "impressions": 9,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage4",
                                "clicks": 0,
                                "impressions": 5,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage5",
                                "clicks": 0,
                                "impressions": 3,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage6",
                                "clicks": 0,
                                "impressions": 4,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            }
                        ],
                        "tablet": [
                            {
                                "ad_position": "MainLine2",
                                "clicks": 2,
                                "impressions": 234,
                                "average_cpc": 0.03,
                                "ctr": 0.8547008633613586,
                                "total_cost": 0.06,
                                "average_bid": 0.0517521367521368
                            },
                            {
                                "ad_position": "MainLine3",
                                "clicks": 0,
                                "impressions": 120,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0515
                            },
                            {
                                "ad_position": "MainLine4",
                                "clicks": 0,
                                "impressions": 29,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.0586206896551724
                            },
                            {
                                "ad_position": "FirstPage1",
                                "clicks": 0,
                                "impressions": 6,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.213333333333333
                            },
                            {
                                "ad_position": "MainLine1",
                                "clicks": 1,
                                "impressions": 121,
                                "average_cpc": 0.05,
                                "ctr": 0.8264462947845459,
                                "total_cost": 0.05,
                                "average_bid": 0.0505785123966942
                            },
                            {
                                "ad_position": "FirstPage3",
                                "clicks": 0,
                                "impressions": 2,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage4",
                                "clicks": 0,
                                "impressions": 1,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage6",
                                "clicks": 0,
                                "impressions": 1,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.05
                            },
                            {
                                "ad_position": "FirstPage5",
                                "clicks": 0,
                                "impressions": 1,
                                "average_cpc": 1,
                                "ctr": 0,
                                "total_cost": 0,
                                "average_bid": 0.15
                            }
                        ]
                    }
                }
            ]
        }
    ]
}